///////////////////////////////////////////////////////////
// Shader Showcase - Main Script File
//
// (c) 2009 by Claus N.
// www.nighthawk.dk
///////////////////////////////////////////////////////////
#include <acknex.h>
#include <mtlView.c>
#include <mtlFX.c>
///////////////////////////////////////////////////////////
#define true 1
#define false 0
#define null NULL

#define SCENE_EMPTY 0
#define SCENE_DEFSHADERS 1
#define SCENE_TOON 2
#define SCENE_TERRAIN 3
///////////////////////////////////////////////////////////
var CurrentScene = SCENE_EMPTY;
var MainMenuVisible = false;
///////////////////////////////////////////////////////////
void MainMenu_Show();
void MainMenu_Hide();
void MainMenu_Toggle();
void InfoPan_Toggle();
void Credits_Hide();
void Credits_HideCFMM();
void Credits_Show();
void Credits_Toggle();
void Scene1_HideOptionsPan();
void LoadScene(int _num);
///////////////////////////////////////////////////////////
FONT* default_font = "Arial#18";
///////////////////////////////////////////////////////////
ENTITY* theSky = 
{
	type = "skycube+6.tga";
	flags2 = SKY | CUBE;
}
///////////////////////////////////////////////////////////
#include <splash.c>
#include <music.c>
#include <menu.c>
#include <credits.c>
#include <mouse.c>
#include <keybindings.c>
#include <animation.c>
#include <particles.c>
#include <scenemanager.c>
#include <scene1.c>
#include <scene2.c>
#include <scene3.c>
///////////////////////////////////////////////////////////
function main()
{
	// Setup video modes
	video_mode = 9;
	video_depth = 32;
	video_screen = 1;
	
	// Turn on AA
	//d3d_antialias = 1;
	
	// Set background-color
	screen_color.red = 1;
	screen_color.green = 1;
	screen_color.blue = 1;
	
	// Start with 75% volume
	midi_vol = 75;
	
	wait(1);
	
	// Eventually show a splashscreen
	#ifdef USE_SPLASH
	
	// - No need to use a splashscreen for A7 - http://www.opserver.de/ubb7/ubbthreads.php?ubb=showflat&Number=283262
	//splashShow();	// Fade in splash screen
	//wait(-3.5);		// Wait a bit
	//splashHide();	// Then hide it again
	//wait(-1);		// Wait till it's gone
	playIntroMovie();	// Play the intro movie
	
	// Wait till the movie is finished
	while(media_playing(MovieHandle))
	{
		// Any key would stop the movie
		if(key_any) {media_stop(MovieHandle);}
		
		wait(1);
	}
	
	#endif
	
	// Play background music
	musicSetActive(musicMenu,false);
	musicDoLoop(musicMenu,50,200);
	
	// Show the mouse
	setMouse(true);
	
	// Set keybindings
	setKeybindings();
	
	// Hide the info panel
	InfoPan_Hide();
	
	// Show the fading panel
	fadeMapShow();
	
	// Load the menu BG
	LoadScene(SCENE_EMPTY);
	
	// Fade in from black
	fadeIn();
	
	// Show the main menu
	MainMenu_Show();
	
	// Place the volume panel in the upper-right corner
	VolumePan.pos_x = screen_size.x - bmap_width(VolumePan.bmap);
	VolumePan.pos_y = 0;
	VolumePan.flags |= SHOW;
}
///////////////////////////////////////////////////////////