///////////////////////////////////////////////////////////
// Shader Showcase - Menu system
//
// (c) 2009 by Claus N.
// www.nighthawk.dk
///////////////////////////////////////////////////////////
BMAP* MainMenuBG = "MainMenuBG.tga";
BMAP* InfoPanBG = "MainMenuBG.tga";
BMAP* VolumePanMap = "GlobalVolume.tga";
BMAP* MainMenuButton_SC1 = "MMBut_SC1.bmp";
BMAP* MainMenuButton_SC2 = "MMBut_SC2.bmp";
BMAP* MainMenuButton_SC3 = "MMBut_SC3.bmp";
BMAP* MainMenuButton_CR = "MMBut_CR.bmp";
BMAP* MainMenuButton_EX = "MMBut_EX.bmp";
BMAP* MainMenuButton_SC1_HOver = "MMButHOver_SC1.bmp";
BMAP* MainMenuButton_SC2_HOver = "MMButHOver_SC2.bmp";
BMAP* MainMenuButton_SC3_HOver = "MMButHOver_SC3.bmp";
BMAP* MainMenuButton_CR_HOver = "MMButHOver_CR.bmp";
BMAP* MainMenuButton_EX_HOver = "MMButHOver_EX.bmp";
BMAP* InfoPanButton_Help = "IPBut_Help.bmp";
BMAP* InfoPanButton_Info = "IPBut_Info.bmp";
BMAP* InfoPanButton_Hide = "IPBut_Hide.bmp";
BMAP* InfoPanButton_Help_HOver = "IPButHOver_Help.bmp";
BMAP* InfoPanButton_Info_HOver = "IPButHOver_Info.bmp";
BMAP* InfoPanButton_Hide_HOver = "IPButHOver_Hide.bmp";
BMAP* MainMenuButton_Back = "MMBut_Back.bmp";
BMAP* MainMenuButton_Back_HOver = "MMButHOver_Back.bmp";

BMAP* SliderMap = "Slider.tga";
///////////////////////////////////////////////////////////
STRING* InfoTextStr = "#512";
///////////////////////////////////////////////////////////
var InfoPan_HiddenPos = -322;
var InfoPan_ShownPos = 20;
var InfoPan_ScrollTime = 30;
var InfoTextOffsetY = 80;
///////////////////////////////////////////////////////////
void MenuButtonClicked(var num,PANEL* pan);
void InfoPanButtonClicked(var num,PANEL* pan);
void Scene1_InfoPanClicked(var num);
void Scene2_InfoPanClicked(var num);
void Scene3_InfoPanClicked(var num);
void InfoPan_Hide();
///////////////////////////////////////////////////////////
PANEL* MainMenu = 
{
	layer = 10;
	bmap = MainMenuBG;
	button(96,32,MainMenuButton_SC1,MainMenuButton_SC1,MainMenuButton_SC1_HOver,MenuButtonClicked,null,null);
	button(96,95,MainMenuButton_SC2,MainMenuButton_SC2,MainMenuButton_SC2_HOver,MenuButtonClicked,null,null);
	button(96,158,MainMenuButton_SC3,MainMenuButton_SC3,MainMenuButton_SC3_HOver,MenuButtonClicked,null,null);
	button(96,221,MainMenuButton_CR,MainMenuButton_CR,MainMenuButton_CR_HOver,MenuButtonClicked,null,null);
	button(96,284,MainMenuButton_EX,MainMenuButton_EX,MainMenuButton_EX_HOver,MenuButtonClicked,null,null);
}
///////////////////////////////////////////////////////////
PANEL* InfoPan =
{
	pos_x = 20;
	layer = 1;
	bmap = InfoPanBG;
	button(96,328,InfoPanButton_Help,InfoPanButton_Help,InfoPanButton_Help_HOver,InfoPanButtonClicked,null,null);
	button(160,328,InfoPanButton_Info,InfoPanButton_Info,InfoPanButton_Info_HOver,InfoPanButtonClicked,null,null);
	button(128,32,InfoPanButton_Hide,InfoPanButton_Hide,InfoPanButton_Hide_HOver,InfoPanButtonClicked,null,null);
}
///////////////////////////////////////////////////////////
PANEL* VolumePan = 
{
	bmap = VolumePanMap;
	hslider(86,2,107,SliderMap,0,100,midi_vol);
}
///////////////////////////////////////////////////////////
TEXT* InfoText = 
{
	layer = 2;
	string = InfoTextStr;
	red = 204;
	green = 204;
	blue = 204;
	font = default_font;
	flags |= (CENTER_X | OUTLINE);
}
///////////////////////////////////////////////////////////
void MainMenu_Show()
{
	MainMenu.pos_x = (screen_size.x - bmap_width(MainMenu.bmap)) / 2;
	MainMenu.pos_y = (screen_size.y - bmap_height(MainMenu.bmap)) / 2;
	MainMenu.flags |= SHOW;
	MainMenuVisible = ((MainMenu.flags & SHOW) != false);
	InfoPan_Hide();
	Credits_HideCFMM();
	pp_set(camera,mtl_gaussian);
}
///////////////////////////////////////////////////////////
void MainMenu_Hide()
{
	MainMenu.flags &= ~SHOW;
	MainMenuVisible = ((MainMenu.flags & SHOW) != false);
	pp_set(camera,null);
}
///////////////////////////////////////////////////////////
void MainMenu_Toggle()
{
	if((MainMenu.flags & SHOW) != false && CurrentScene != SCENE_EMPTY)
	{
		MainMenu_Hide();
	}
	else
	{
		MainMenu_Show();
	}
}
///////////////////////////////////////////////////////////
void ExitDemo()
{
	sys_exit("Closing Application.");
}
///////////////////////////////////////////////////////////
void MenuButtonClicked(var num,PANEL* pan)
{
	switch(num)
	{
		case 1:
			LoadScene(SCENE_DEFSHADERS);
			break;
		case 2:
			LoadScene(SCENE_TOON);
			break;
		case 3:
			LoadScene(SCENE_TERRAIN);
			break;
		case 4:
			Credits_Show();
			break;
		case 5:
			ExitDemo();
			break;
	}
}
///////////////////////////////////////////////////////////
void InfoPan_Hide()
{
	InfoText.pos_x = InfoPan.pos_x + bmap_width(InfoPan.bmap) / 2;
	InfoText.pos_y = InfoPan_HiddenPos + InfoTextOffsetY;
	
	InfoPan.pos_y = InfoPan_HiddenPos;
}
///////////////////////////////////////////////////////////
void InfoPan_SetState(var state)
{
	wait(1);
	proc_kill(4);
	
	if(state == false)
	{
		while(InfoPan.pos_y > InfoPan_HiddenPos)
		{
			if(MainMenuVisible != false) {return;}
			
			InfoText.pos_x = InfoPan.pos_x + bmap_width(InfoPan.bmap) / 2;
			InfoText.pos_y = InfoPan.pos_y + InfoTextOffsetY;
			
			InfoPan.pos_y -= InfoPan_ScrollTime * time_step;
			wait(1);
		}
		
		InfoText.pos_x = InfoPan.pos_x + bmap_width(InfoPan.bmap) / 2;
		InfoText.pos_y = InfoPan_HiddenPos + InfoTextOffsetY;
		
		InfoPan.pos_y = InfoPan_HiddenPos;
		
		pp_set(camera,null);
	}
	else
	{
		pp_set(camera,mtl_gaussian);
		
		while(InfoPan.pos_y < InfoPan_ShownPos)
		{
			if(MainMenuVisible != false) {return;}
			
			InfoText.pos_x = InfoPan.pos_x + bmap_width(InfoPan.bmap) / 2;
			InfoText.pos_y = InfoPan.pos_y + InfoTextOffsetY;
			
			InfoPan.pos_y += InfoPan_ScrollTime * time_step;
			wait(1);
		}
		
		InfoText.pos_x = InfoPan.pos_x + bmap_width(InfoPan.bmap) / 2;
		InfoText.pos_y = InfoPan_ShownPos + InfoTextOffsetY;
		
		InfoPan.pos_y = InfoPan_ShownPos;
	}
}
///////////////////////////////////////////////////////////
void InfoPan_Toggle()
{
	if(MainMenuVisible != false) {return;}
	
	if(InfoPan.pos_y >= 0)
	{
		InfoPan_SetState(false);
	}
	else
	{
		InfoPan_SetState(true);
	}
}
///////////////////////////////////////////////////////////
void InfoPanButtonClicked(var num,PANEL* pan)
{
	if(MainMenuVisible != false) {return;}
	
	if(num == 3) {InfoPan_SetState(false);}
	else {InfoPan_SetState(true);}
	
	if(CurrentScene == SCENE_DEFSHADERS) {Scene1_InfoPanClicked(num);}
	if(CurrentScene == SCENE_TOON) {Scene2_InfoPanClicked(num);}
	if(CurrentScene == SCENE_TERRAIN) {Scene3_InfoPanClicked(num);}
}
///////////////////////////////////////////////////////////
