///////////////////////////////////////////////////////////
// Shader Showcase - Particle effects
//
// (c) 2009 by Claus N.
// www.nighthawk.dk
///////////////////////////////////////////////////////////
BMAP* particleFireMap = "fire_particle.tga";
BMAP* particleSmokeMap = "smoke_particle.tga";
BMAP* particle1Map = "particle1.tga";
///////////////////////////////////////////////////////////
void particle_alphafade(PARTICLE* p)
{
	p->alpha -= p->skill_a * time_step;
	
	if(p->bmap == particleFireMap && p->alpha <= 10)
	{
		p->alpha = 10 + random(20);
		p->bmap = particleSmokeMap;
	}
	
	if(p->alpha <= p->skill_b)
	{
		p->lifespan = 0;
	}
}
///////////////////////////////////////////////////////////
void particle_deccelerate(PARTICLE* p)
{
	p->vel_x *= 0.98;
	p->vel_y *= 0.98;
	p->vel_z += p->skill_c * time_step;
	p->alpha -= 4 * time_step;
	if(my.alpha < 80)
	{
		p->event = particle_alphafade;
	}
}
///////////////////////////////////////////////////////////
void particle_accelerate(PARTICLE* p)
{
	p->vel_x *= 1.01;
	p->vel_y *= 1.01;
	p->vel_z += p->skill_c * time_step;
	p->alpha -= 4 * time_step;
	if(my.alpha < 80)
	{
		p->event = particle_alphafade;
	}
}
///////////////////////////////////////////////////////////
void FireEffect(PARTICLE* p)
{
	p->bmap = particleFireMap;
	p->vel_x = random(0.5) - random(0.5);
	p->vel_y = random(0.5) - random(0.5);
	p->vel_z = random(0.25) - random(0.25) + 2;
	p->lifespan = 160;
	p->alpha = 10 + random(20);
	p->size = 4 + random(4);
	p->skill_a = 2;
	p->skill_b = 10;
	p->flags = (MOVE | BRIGHT | (1<<25));
	p->event = particle_alphafade;
}
///////////////////////////////////////////////////////////
void FireEffect2(PARTICLE* p)
{
	p->bmap = particleFireMap;
	p->vel_x = random(4) - random(4);
	p->vel_y = random(4) - random(4);
	p->vel_z = random(0.25) - random(0.25) + 1;
	p->lifespan = 160;
	p->alpha = 10 + random(10);
	p->size = 2 + random(4);
	p->skill_a = 3;
	p->skill_b = 5;
	p->flags = (MOVE | BRIGHT | (1<<25));
	p->event = particle_alphafade;
}
///////////////////////////////////////////////////////////
void ParticleEffect1(PARTICLE* p)
{
	p->bmap = particle1Map;
	p->vel_x = random(0.5) - random(0.5);
	p->vel_y = random(0.5) - random(0.5);
	p->vel_z = random(0.25) - random(0.25) + 2;
	p->lifespan = 160;
	p->alpha = 10 + random(10);
	p->size = 2 + random(4);
	p->skill_a = 5;
	p->skill_b = 10;
	p->flags = (MOVE | BRIGHT | (1<<25));
	p->event = particle_alphafade;
}
///////////////////////////////////////////////////////////
void scene2_dissappearEffect(PARTICLE* p)
{
	p->red = 255;
	p->green = 128;
	p->blue = 64;
	var _ranAngle = random(360);
	p->bmap = particle1Map;
	p->vel_x = fcos(_ranAngle,18);
	p->vel_y = fsin(_ranAngle,18);
	p->vel_z = -1.5;
	p->lifespan = 160;
	p->alpha = 100;
	p->size = 6;
	p->skill_a = 8;
	p->skill_b = 1;
	p->skill_c = 0.5;
	p->flags = (MOVE | BRIGHT | (1<<25));
	p->event = particle_deccelerate;
}
///////////////////////////////////////////////////////////
void scene2_reappearEffect(PARTICLE* p)
{
	p->red = 255;
	p->green = 128;
	p->blue = 64;
	var _ranAngle = random(360);
	p->bmap = particle1Map;
	p->x = p->x + fcos(_ranAngle,-120);
	p->y = p->y + fsin(_ranAngle,-120);
	p->vel_x = fcos(_ranAngle,4);
	p->vel_y = fsin(_ranAngle,4);
	p->vel_z = 0;
	p->lifespan = 160;
	p->alpha = 100;
	p->size = 8;
	p->skill_a = 8;
	p->skill_b = 1;
	p->skill_c = 0;
	p->flags = (MOVE | BRIGHT | (1<<25));
	p->event = particle_accelerate;
}
///////////////////////////////////////////////////////////
