///////////////////////////////////////////////////////////
// Shader Showcase - Loading scenes
//
// (c) 2009 by Claus N.
// www.nighthawk.dk
///////////////////////////////////////////////////////////
STRING* MenuBG_Level = "MenuBG.wmb";
STRING* Scene1_Level = "Scene1.wmb";
STRING* Scene2_Level = "Scene2.wmb";
STRING* Scene3_Level = "Scene3.wmb";
///////////////////////////////////////////////////////////
void ProcessScene1();
void ProcessScene2();
void ProcessScene3();
///////////////////////////////////////////////////////////
var Scene1_Init = 0;
///////////////////////////////////////////////////////////
void LoadScene(int _num)
{
	Scene1_Init = false;
	
	Scene1_HideOptionsPan();
	
	setMouse(true);
	
	fog_color = 0;
	
	theSky.flags2 &= ~SHOW;
	
	if(_num == SCENE_DEFSHADERS)
	{
		fadeIn();
		MainMenu_Hide();
		level_load(Scene1_Level);
		CurrentScene = SCENE_DEFSHADERS;
		ProcessScene1();
	}
	else if(_num == SCENE_TOON)
	{
		fadeIn();
		MainMenu_Hide();
		level_load(Scene2_Level);
		CurrentScene = SCENE_TOON;
		ProcessScene2();
	}
	else if(_num == SCENE_TERRAIN)
	{
		fadeIn();
		MainMenu_Hide();
		theSky.flags2 |= SHOW;
		level_load(Scene3_Level);
		CurrentScene = SCENE_TERRAIN;
		ProcessScene3();
	}
	else if(_num == SCENE_EMPTY)
	{
		level_load(MenuBG_Level);
	}
}
///////////////////////////////////////////////////////////
action MenuBG_Fire()
{
	my.red = 255;
	my.green = 204;
	my.blue = 64;
	
	my.flags |= INVISIBLE;
	
	while(my)
	{
		vec_set(target,my.x);
		target.x += random(8) - random(8);
		target.y += random(8) - random(8);
		target.z += random(4) - random(4) - 20;
		
		effect(FireEffect,5,target,nullvector);
		
		my.lightrange = clamp(my.lightrange + (random(50) - random(50)) * time_step,250,400);
		
		wait(1);
	}
}
///////////////////////////////////////////////////////////
