///////////////////////////////////////////////////////////
// Shader Showcase - Splash Screen
//
// (c) 2009 by Claus N.
// www.nighthawk.dk
///////////////////////////////////////////////////////////
#define USE_SPLASH
///////////////////////////////////////////////////////////
STRING* IntroMovie = "ZofteyezLogoHQ-Fade.avi";

BMAP* splashMap = "logo_800.jpg";
BMAP* _blackMap = "black.pcx";

var MovieHandle = 0;
var screenFadeSpeed = 10;
///////////////////////////////////////////////////////////
PANEL* splashPan =
{
	bmap = splashMap;
	flags |= TRANSLUCENT;
}
///////////////////////////////////////////////////////////
PANEL* blackMap =
{
	bmap = _blackMap;
	flags |= TRANSLUCENT;
	layer = 20;
}
///////////////////////////////////////////////////////////
void splashShow()
{
	splashPan.pos_x = (screen_size.x - bmap_width(splashPan.bmap)) / 2;
	splashPan.pos_y = (screen_size.y - bmap_height(splashPan.bmap)) / 2;
	splashPan.alpha = 0;
	splashPan.flags |= SHOW;
	
	while(splashPan.alpha < 100)
	{
		splashPan.alpha += 10 * time_step;
		wait(1);
	}
	
	splashPan.flags &= ~TRANSLUCENT;
}
///////////////////////////////////////////////////////////
void splashHide()
{
	splashPan.flags |= TRANSLUCENT;
	
	while(splashPan.alpha > 0)
	{
		splashPan.alpha -= 10 * time_step;
		wait(1);
	}
	
	splashPan.flags &= ~SHOW;
	bmap_purge(splashPan.bmap);
}
///////////////////////////////////////////////////////////
void playIntroMovie()
{
	if(media_playing(MovieHandle)) {media_stop(MovieHandle);}
	
	MovieHandle = media_play(IntroMovie,NULL,100);
}
///////////////////////////////////////////////////////////
var fadeMapVisible()
{
	return (blackMap.flags & SHOW);
}
///////////////////////////////////////////////////////////
void fadeMapShow()
{
	blackMap.alpha = 100;
	blackMap.scale_x = screen_size.x;
	blackMap.scale_y = screen_size.y;
	blackMap.flags |= SHOW;
}
///////////////////////////////////////////////////////////
void fadeIn()
{
	blackMap.alpha = 100;
	blackMap.scale_x = screen_size.x;
	blackMap.scale_y = screen_size.y;
	blackMap.flags |= SHOW;
	
	while(blackMap.alpha > 0)
	{
		blackMap.alpha -= screenFadeSpeed * time_step;
		wait(1);
	}
	
	blackMap.flags &= ~SHOW;
}
///////////////////////////////////////////////////////////
